

/*
*******************************************************************************
Include Part
*******************************************************************************
*/
#include "buzz.h"
#include "util.h"
#include "main.h"
/*
*******************************************************************************
Define Part
*******************************************************************************
*/
#define BUZZ_STEP_0		0
#define BUZZ_STEP_1		1
#define BUZZ_STEP_2		2
#define BUZZ_STEP_3		3
#define BUZZ_STEP_4		4
#define BUZZ_STEP_5		5
#define BUZZ_STEP_6		6
/*
********************************************************************************
Variable Declaration Part
********************************************************************************
*/
unsigned char old_buzz_1_step = BUZZ_STEP_0;
unsigned char buzz_1_step = BUZZ_STEP_1;
//
unsigned char old_buzz_2_step = BUZZ_STEP_0;
unsigned char buzz_2_step = BUZZ_STEP_1;
//
unsigned char timer_buzz_3_operation = OPERATION_NO;
/*
********************************************************************************

********************************************************************************
*/
void BUZZ_ON()
{
	sbi(PORTE,PE5);
}
/*
********************************************************************************

********************************************************************************
*/
void BUZZ_OFF()
{
	cbi(PORTE,PE5);
}
/*
********************************************************************************

********************************************************************************
*/
void CHECK_TIMER_BUZZ_1()
{
	if(timer_buzz_1 == 0)
	{
		buzz_1_step = old_buzz_1_step;
		buzz_1_step++;
	}
}
/*
********************************************************************************

********************************************************************************
*/
void CHECK_TIMER_BUZZ_2()
{
	if(timer_buzz_2 == 0)
	{
		buzz_2_step = old_buzz_2_step;
		buzz_2_step++;
	}
}
/*
********************************************************************************

********************************************************************************
*/
void START_TIMER_BUZZ_1()
{
	old_buzz_1_step = buzz_1_step;
	buzz_1_step = BUZZ_STEP_0;
	//
	//Է°  3 ð ҿ : 20*3 = 60ms
	timer_buzz_1 = 20;
}
/*
********************************************************************************

********************************************************************************
*/
void START_TIMER_BUZZ_2()
{
	old_buzz_2_step = buzz_2_step;
	buzz_2_step = BUZZ_STEP_0;
	//
	//Է°  3 ð ҿ : 20*3 = 60ms
	timer_buzz_2 = 20;
}
/*
********************************************************************************

********************************************************************************
*/
void START_TIMER_BUZZ_3()
{
	if(timer_buzz_3_operation == OPERATION_NO)
	{
		timer_buzz_3_operation = OPERATION_OK;
		//
		//Է°  3 ð ҿ : 2000*3 = 6000ms
		timer_buzz_3 = 2000;
	}
}
/*
********************************************************************************

********************************************************************************
*/
void INIT_BUZZ()
{
	BUZZ_ON();
	WAIT_1MS(40);
	BUZZ_OFF();
	WAIT_1MS(20);
	BUZZ_ON();
	WAIT_1MS(20);
	BUZZ_OFF();
}
/*
********************************************************************************
BUZZ_PROCESS
********************************************************************************
*/
void BUZZ_PROCESS()
{
	unsigned char dip_switch_value;
	//
	//KEY(2) (Tact ġ ) ̿Ͽ  Ѵ.
	//KEY(2) (Tact ġ )  ,  Ѵ.
	if((operation_key_2_number> 0)&&(operation_key_2_process == OPERATION_OK))
	{
		switch(buzz_1_step)
		{
			//ð  üũ  Timer_buzz_1  0 ȴ üũϴ ƾ
			case BUZZ_STEP_0:
				CHECK_TIMER_BUZZ_1();
				break;
			case BUZZ_STEP_1:
				BUZZ_ON();
				START_TIMER_BUZZ_1();
				break;
			case BUZZ_STEP_2:
				BUZZ_OFF();
				START_TIMER_BUZZ_1();
				break;
			case BUZZ_STEP_3:
				BUZZ_ON();
				START_TIMER_BUZZ_1();
				break;
			case BUZZ_STEP_4:
				BUZZ_OFF();
				START_TIMER_BUZZ_1();
				break;
			case BUZZ_STEP_5:
				BUZZ_ON();
				START_TIMER_BUZZ_1();
				break;
			case BUZZ_STEP_6:
				BUZZ_OFF();
				//
				old_buzz_1_step = BUZZ_STEP_0;
				buzz_1_step = BUZZ_STEP_1;
				//
				operation_key_2_number = 0;
				operation_key_2_process = OPERATION_NO;
				break;
			default:
				BUZZ_OFF();
				break;
		}
	}
	//
	//KEY(2) (Tact ġ )   
	else
	{
		//KEY(2) (Tact ġ ) ̿Ͽ    
		operation_key_2_number = 0;
		operation_key_2_process = OPERATION_NO;
		//
		//Dip Switch  д´.
		dip_switch_value = ((PINE & 0xc0)>>4);
		dip_switch_value |= (PIND & 0x03);
		//
		//4 Dip Switch High ,  
		if((dip_switch_value & 0x02) == 0x02)//xxx1
		{
			//COUNT ͸ ̿Ͽ  Ѵ.
			//COUNT ͸   ,  Ѵ.
			//
			//timer_buzz_3 ð  ϰ Ѵ. ð  Ϸ  1ȸ .
			START_TIMER_BUZZ_3();
			//
			//timer_buzz_3 ð   , Ѵ.
			if(timer_buzz_3 == 0)
			{
				//COUNT ͸ ϸ, timer_buzz_3  ٽ 2000 Ѵ.
				if((operation_count_number> 0)&&(operation_count_process == OPERATION_OK))
				{
					BUZZ_OFF();
					//
					timer_buzz_3_operation = OPERATION_OK;
					timer_buzz_3 = 2000;
					//
					buzz_2_step = BUZZ_STEP_1;
					old_buzz_2_step = BUZZ_STEP_0;
					//
					operation_count_number = 0;
					operation_count_process = OPERATION_NO;
				}
				//
				//COUNT ͸   ,  Ѵ.
				else
				{
					operation_count_number = 0;
					operation_count_process = OPERATION_NO;
					//
					switch(buzz_2_step)
					{
						case BUZZ_STEP_0:
							CHECK_TIMER_BUZZ_2();
							break;
						case BUZZ_STEP_1:
							BUZZ_ON();
							START_TIMER_BUZZ_2();
							break;
						case BUZZ_STEP_2:
							BUZZ_OFF();
							START_TIMER_BUZZ_2();
							break;
						case BUZZ_STEP_3:
							BUZZ_ON();
							START_TIMER_BUZZ_2();
							break;
						case BUZZ_STEP_4:
							BUZZ_OFF();
							START_TIMER_BUZZ_2();
							break;
						case BUZZ_STEP_5:
							BUZZ_ON();
							START_TIMER_BUZZ_2();
							break;
						case BUZZ_STEP_6:
							BUZZ_OFF();
							//
							buzz_2_step = BUZZ_STEP_1;
							old_buzz_2_step = BUZZ_STEP_0;
							//
							timer_buzz_3_operation = OPERATION_OK;
							timer_buzz_3 = 2000;
							break;
						default:
							BUZZ_OFF();
							break;
					}
				};
			}
		}
	};
}

