

/*
*******************************************************************************
Include Part
*******************************************************************************
*/
#include "change_address.h"
#include "util.h"
#include "main.h"
/*
*******************************************************************************
Define Part
*******************************************************************************
*/
#define	CHANGE_ADDRESS_STEP_0	0
#define	CHANGE_ADDRESS_STEP_1	1
#define	CHANGE_ADDRESS_STEP_2	2
//
#define CHANGE_NUMBER_0		0
#define CHANGE_NUMBER_LCD 	1
#define CHANGE_NUMBER_FND 	2
#define CHANGE_NUMBER_BUZZ_1 	3
#define CHANGE_NUMBER_BUZZ_2 	4
#define CHANGE_NUMBER_LED 	5
/*
********************************************************************************
Variable Declaration Part
********************************************************************************
*/
unsigned char change_address_step = CHANGE_ADDRESS_STEP_0;
unsigned char change_number = CHANGE_NUMBER_0;
unsigned char save_ok = 0;
/*
********************************************************************************
Function
********************************************************************************
*/
/*
********************************************************************************
CHANGE_ADDRESS_PROCESS
********************************************************************************
*/
void CHANGE_ADDRESS_PROCESS()
{
	unsigned int uart1_length;
	unsigned char uart1_parsing_buf[20];
	unsigned char loof_count;
	unsigned char address_buf[20];
	unsigned char before_char,after_char;
	//
	uart1_length = CHECK_RX_BUF_UART1();
	//
	// Է  ̸ 20ڷ Ѵ.
	if(uart1_length > 20)
	{
		for(loof_count = 0;loof_count < uart1_length;loof_count++)
		{
			GETCHAR_UART1();
		}
		DISPSTR_UART1((unsigned char *)"\r\n\r\nOVER FLOW\r\n\r\n");
		return;
	}
	//
	for(loof_count = 0;loof_count < uart1_length;loof_count++)
	{
		uart1_parsing_buf[loof_count] = GETCHAR_UART1();
	}
	//
	switch(change_address_step)
	{
		case CHANGE_ADDRESS_STEP_0:
			if( (uart1_length == 2)
			&&((uart1_parsing_buf[0] == 'c')||(uart1_parsing_buf[0] == 'C')))
			{
				change_address_step++;
				DISPSTR_UART1((unsigned char *)"\r\n*********************************************\r\n");
				DISPSTR_UART1((unsigned char *)"[1: CHANGE LCD OPERATION ADDRESS]\r\n");
				DISPSTR_UART1((unsigned char *)"[2: CHANGE FND OPERATION ADDRESS]\r\n");
				DISPSTR_UART1((unsigned char *)"[3: CHANGE BUZZ 1 OPERATION ADDRESS]\r\n");
				DISPSTR_UART1((unsigned char *)"[4: CHANGE BUZZ 2 OPERATION ADDRESS]\r\n");
				DISPSTR_UART1((unsigned char *)"[5: CHANGE LED OPERATION ADDRESS]\r\n");
				DISPSTR_UART1((unsigned char *)"[T: RETURN TOP MENU]\r\n");
				DISPSTR_UART1((unsigned char *)"*********************************************\r\n");
				DISPSTR_UART1((unsigned char *)"[SELECT NUMBER]\r\n");
				DISPSTR_UART1((unsigned char *)"*********************************************\r\n");
			}
			else if( (uart1_length == 2)
			&&((uart1_parsing_buf[0] == 't')||(uart1_parsing_buf[0] == 'T')))
			{
				change_address_step = CHANGE_ADDRESS_STEP_0;
				change_number = CHANGE_NUMBER_0;
				DISPSTR_UART1((unsigned char *)"\r\nRETURN\r\n\r\n");
				DISPLAY_EEPROM_DATA();
			}
			else
			{
				DISPSTR_UART1((unsigned char *)"\r\nERROR\r\n\r\n");
			};
			break;
		case CHANGE_ADDRESS_STEP_1:
			if( (uart1_length == 2)
			&&((uart1_parsing_buf[0] == 't')||(uart1_parsing_buf[0] == 'T')))
			{
				change_address_step = 0;
				change_number = CHANGE_NUMBER_0;
				DISPSTR_UART1((unsigned char *)"\r\nRETURN\r\n\r\n");
				DISPLAY_EEPROM_DATA();
			}
			else if( (uart1_length == 2)
			&&(uart1_parsing_buf[0] == '1'))
			{
				change_number = CHANGE_NUMBER_LCD;
				change_address_step++;
				DISPSTR_UART1((unsigned char *)"LCD OPERATION ADDRESS: ");
			}
			else if( (uart1_length == 2)
			&&(uart1_parsing_buf[0] == '2'))
			{
				change_number = CHANGE_NUMBER_FND;
				change_address_step++;
				DISPSTR_UART1((unsigned char *)"FND OPERATION ADDRESS: ");
			}
			else if( (uart1_length == 2)
			&&(uart1_parsing_buf[0] == '3'))
			{
				change_number = CHANGE_NUMBER_BUZZ_1;
				change_address_step++;
				DISPSTR_UART1((unsigned char *)"BUZZ 1 OPERATION ADDRESS: ");
			}
			else if( (uart1_length == 2)
			&&(uart1_parsing_buf[0] == '4'))
			{
				change_number = CHANGE_NUMBER_BUZZ_2;
				change_address_step++;
				DISPSTR_UART1((unsigned char *)"BUZZ 2 OPERATION ADDRESS: ");
			}
			else if( (uart1_length == 2)
			&&(uart1_parsing_buf[0] == '5'))
			{
				change_number = CHANGE_NUMBER_LED;
				change_address_step++;
				DISPSTR_UART1((unsigned char *)"LED OPERATION ADDRESS: ");
			}
			else
			{
				DISPSTR_UART1((unsigned char *)"\r\nERROR\r\n\r\n");
			};
			break;
		case CHANGE_ADDRESS_STEP_2:
			if( (uart1_length == 17)
			&&(uart1_parsing_buf[0] == '0')
			&&(uart1_parsing_buf[1] == '0')
			&&(uart1_parsing_buf[2] == '1')
			&&(uart1_parsing_buf[3] == '5')
			&&(uart1_parsing_buf[4] == '5')
			&&(uart1_parsing_buf[5] == '1'))
			{
				// ҹڰ Էµ ,  ҹڸ  빮ڷ Ѵ.
				for(loof_count = 0;loof_count<20;loof_count++)
					address_buf[loof_count] = 0x00;
				for(loof_count = 0;loof_count<16;loof_count++)
				{
					before_char = uart1_parsing_buf[loof_count];
					//
					if(before_char >= 'a' && before_char <= 'z')
						after_char = before_char - 0x20;
					else
						after_char = before_char;
					//
					address_buf[loof_count] = after_char;
				}
				//
				if(change_number == CHANGE_NUMBER_LCD)
				{
					memcpy(received_adc_address,address_buf,16);
					eeprom_write_block(received_adc_address, (void *)EEPROM_ADC_ADDRESS, 16);
					eeprom_read_block(received_adc_address, (void *)EEPROM_ADC_ADDRESS, 16);
					save_ok = 1;
				}
				else if(change_number == CHANGE_NUMBER_FND)
				{
					memcpy(received_key_1_address,address_buf,16);
					eeprom_write_block(received_key_1_address, (void *)EEPROM_KEY_1_ADDRESS, 16);
					eeprom_read_block(received_key_1_address, (void *)EEPROM_KEY_1_ADDRESS, 16);
					save_ok = 1;
				}
				else if(change_number == CHANGE_NUMBER_BUZZ_1)
				{
					memcpy(received_key_2_address,address_buf,16);
					eeprom_write_block(received_key_2_address, (void *)EEPROM_KEY_2_ADDRESS, 16);
					eeprom_read_block(received_key_2_address, (void *)EEPROM_KEY_2_ADDRESS, 16);
					save_ok = 1;
				}
				else if(change_number == CHANGE_NUMBER_BUZZ_2)
				{
					memcpy(received_count_address,address_buf,16);
					eeprom_write_block(received_count_address, (void *)EEPROM_COUNT_ADDRESS, 16);
					eeprom_read_block(received_count_address, (void *)EEPROM_COUNT_ADDRESS, 16);
					save_ok = 1;
				}
				else if(change_number == CHANGE_NUMBER_LED)
				{
					memcpy(received_gpio_address,address_buf,16);
					eeprom_write_block(received_gpio_address, (void *)EEPROM_GPIO_ADDRESS, 16);
					eeprom_read_block(received_gpio_address, (void *)EEPROM_GPIO_ADDRESS, 16);
					save_ok = 1;
				}
				//
				if(save_ok == 1)
				{
					save_ok = 0;
					change_address_step = 0;
					change_number = CHANGE_NUMBER_0;
					DISPSTR_UART1((unsigned char *)"\r\n\r\nCHANGE ADDRESS OK\r\n\r\n");
					DISPLAY_EEPROM_DATA();
				}
			}
			else if( (uart1_length == 2)
			&&((uart1_parsing_buf[0] == 't')||(uart1_parsing_buf[0] == 'T')))
			{
				change_address_step = 0;
				change_number = CHANGE_NUMBER_0;
				DISPSTR_UART1((unsigned char *)"\r\nRETURN\r\n\r\n");
				DISPLAY_EEPROM_DATA();
			}
			else
			{
				change_address_step = 0;
				change_number = CHANGE_NUMBER_0;
				DISPSTR_UART1((unsigned char *)"\r\n\r\nERROR\r\n\r\n");
				DISPLAY_EEPROM_DATA();
			};
			break;
	}
}



