

/*
*******************************************************************************
Include Part
*******************************************************************************
*/
#include "lcd.h"
#include "util.h"
#include "main.h"
/*
*******************************************************************************
Define Part
*******************************************************************************
*/
#define LCD_EN_0 cbi(PORTE,PE4)
#define LCD_EN_1 sbi(PORTE,PE4)
#define LCD_RW_0 cbi(PORTE,PE3)
#define LCD_RS_0 cbi(PORTE,PE2)
#define LCD_RS_1 sbi(PORTE,PE2)
//
/*
********************************************************************************
Variable Declaration Part
********************************************************************************
*/
/*
********************************************************************************

********************************************************************************
*/
void LCD_INITIALIZE()
{
	WAIT_1MS(40);
	//
	LCD_WRITE_COMMAND(0x38);
	WAIT_1MS(5);
	//
	WAIT_1MS(20);
	//
	LCD_WRITE_COMMAND(0x38);
	WAIT_1MS(5);
	//
	WAIT_1MS(1);
	//
	LCD_WRITE_COMMAND(0x38);
	WAIT_1MS(5);
	//
	LCD_WRITE_COMMAND(0x38);
	WAIT_1MS(5);
	//
	LCD_WRITE_COMMAND(0x0f);
	WAIT_1MS(5);
	//
	LCD_WRITE_COMMAND(0x06);
	WAIT_1MS(5);
	//
	LCD_WRITE_COMMAND(0x02);
	WAIT_1MS(5);
	//
	LCD_WRITE_COMMAND(0x01);
	WAIT_1MS(5);
}
/*
********************************************************************************

********************************************************************************
*/
void LCD_CLEAR_SCREEN()
{
	LCD_WRITE_COMMAND(0x01);
	WAIT_1MS(5);
	//
	WAIT_1MS(10);
}
/*
********************************************************************************

********************************************************************************
*/
void LCD_CURSOR_OFF()
{
	LCD_WRITE_COMMAND(0x0c);
	WAIT_1MS(5);
	//
	WAIT_1MS(10);
}
/*
********************************************************************************

********************************************************************************
*/
void LCD_WRITE_COMMAND(unsigned char lcd_command)
{
	LCD_EN_0;
	LCD_RW_0;
	LCD_RS_0;
	//
	LCD_EN_1;
	LCD_RW_0;
	LCD_RS_0;
	//
	PORTF = lcd_command;
	//
	LCD_EN_0;
	LCD_RW_0;
	LCD_RS_0;
}
/*
********************************************************************************

********************************************************************************
*/
void LCD_WRITE_DATA(unsigned char lcd_data)
{
	LCD_EN_0;
	LCD_RW_0;
	LCD_RS_1;
	//
	LCD_EN_1;
	LCD_RW_0;
	LCD_RS_1;
	//
	PORTF = lcd_data;
	//
	LCD_EN_0;
	LCD_RW_0;
	LCD_RS_1;
}
/*
********************************************************************************

********************************************************************************
*/
void LCD_DISPLAY_STRING(unsigned char *str)
{
	while(*str)
	{
		LCD_WRITE_DATA(*str++);
		WAIT_1MS(5);
	}
}
/*
********************************************************************************

********************************************************************************
*/
/*
********************************************************************************

********************************************************************************
*/
/*
********************************************************************************

********************************************************************************
*/
void INIT_LCD()
{
	LCD_INITIALIZE();
	LCD_CLEAR_SCREEN();
	LCD_WRITE_COMMAND(0x80);
	WAIT_1MS(5);
	LCD_DISPLAY_STRING((unsigned char *)"Firmtech.co.,LTD");
	LCD_WRITE_COMMAND(0xc0);
	WAIT_1MS(5);
	LCD_DISPLAY_STRING((unsigned char *)"FZ800ED_KEY_V010");
	LCD_CURSOR_OFF();
}
/*
********************************************************************************
LCD_PROCESS
********************************************************************************
*/
void LCD_PROCESS()
{

}


