
/*
*******************************************************************************
	Sequence Description
*******************************************************************************
*/
/*
*******************************************************************************
Include Part
*******************************************************************************
*/
#include "main.h"
#include "util.h"
//
#include "parsing_count.h"
//
#include "buzz.h"
#include "fnd.h"
#include "lcd.h"
#include "led.h"
/*
*******************************************************************************
Define Part
*******************************************************************************
*/
//
#define	STEP_0_INIT_EEPROM		0x00
#define	STEP_1_DISP_EEPROM		0x01
#define	STEP_2_CHECK_CR_LF		0x02
#define	STEP_3_DATA_PARSING		0x03
//
#define RESET_PORT_HIGH	sbi(PORTC,PC1)
#define RESET_PORT_LOW		cbi(PORTC,PC1)
//
/*
********************************************************************************
Variable Declaration Part
********************************************************************************
*/
unsigned char step_count;
//
/*
********************************************************************************
Function For Initialize PORT
********************************************************************************
*/
void INIT_PORT ()
{
	//Ʈ A  (= 1111 1111)
	DDRA  = 0xff;
	//Ʈ A ʱⰪ 
	PORTA = 0x00;
	//
	//Ʈ B  (= 1111 1111)
	DDRB  = 0xff;
	//Ʈ B ʱⰪ High (= 1111 1111)
	PORTB = 0xff;
	//
	//Ʈ C  
	DDRC  = 0x03;
	//Ʈ C ʱⰪ High (= 1111 1111)
	PORTC = 0x03;
	//
	//Ʈ D  
	DDRD  = 0x38;
	//Ʈ D ʱⰪ High (= 1111 1111)
	PORTD = 0x38;
	//
	//Ʈ E  
	DDRE  = 0x3e;
	//Ʈ E ʱⰪ 
	PORTE = 0x1f;
	//
	//Ʈ F  (= 1111 1111)
	DDRF  = 0xff;
	//Ʈ F ʱⰪ High (= 1111 1111)
	PORTF = 0xff;
	//
	//Ʈ G  (= xxx1 1111)
	DDRG = 0x00;
	//Ʈ G ʱⰪ High (= 1111 1111)
	PORTG = 0xff;
}
/*
********************************************************************************

********************************************************************************
*/
void DISPLAY_EEPROM_DATA()
{
	unsigned int loof_count;
	//
	DISPSTR_UART1((unsigned char *)"*********************************************\r\n");
	DISPSTR_UART1((unsigned char *)"PARSING DATA TYPE      : ");
	DISPSTR_UART1(received_data_type);
	DISPSTR_UART1((unsigned char *)"\r\n");
	DISPSTR_UART1((unsigned char *)"PARSING DATA VALUE MIN : ");
	DISPSTR_UART1(received_data_value_min);
	DISPSTR_UART1((unsigned char *)"\r\n");
	DISPSTR_UART1((unsigned char *)"PARSING DATA VALUE MAX : ");
	DISPSTR_UART1(received_data_value_max);
	DISPSTR_UART1((unsigned char *)"\r\n");
	DISPSTR_UART1((unsigned char *)"PARSING DATA ADDRESS   : ");
	DISPSTR_UART1(received_data_address);
	DISPSTR_UART1((unsigned char *)"\r\n*********************************************\r\n");
	//
	//UART0_BUF ʱȭ
	p_rx0_wr = 0;
	p_rx0_rd = 0;
	for (loof_count=0; loof_count<UART0_BUF_SIZE; loof_count++) rx0_buf[loof_count] = 0;
	//UART1_BUF ʱȭ
	p_rx1_wr = 0;
	p_rx1_rd = 0;
	for (loof_count=0; loof_count<UART1_BUF_SIZE; loof_count++) rx1_buf[loof_count] = 0;
}
/*
********************************************************************************

********************************************************************************
*/
void CHECK_CR_LF_PROCESS()
{
	if((cr0_check_flag == 1)&&(lf_check_flag == 1))
	{
		cr0_check_flag = 0;
		lf_check_flag = 0;
		step_count = STEP_3_DATA_PARSING;
	}
}
/*
********************************************************************************

********************************************************************************
*/
void CHECK_USERS_INPUT_DATA()
{
	unsigned int uart1_length;
	unsigned char loof_count;
	//
	//---------------------------------------
	uart1_length = CHECK_RX_BUF_UART1();
	if(uart1_length > 0)
	{
		for(loof_count = 0;loof_count < uart1_length;loof_count++)
		{
			PUTCHAR_UART0(GETCHAR_UART1());
		}
	}
	//---------------------------------------
}
/*
********************************************************************************

********************************************************************************
*/
void USERS_OPERATION()
{
	if(execution_users_operation == EXECUTION_OK)
	{
		//---------------------------------------
		if(execution_count < 5000)
		{
			LED_2_ON;
			BUZZ_ON();
		}
		else if(execution_count < 10000)
		{
			LED_2_OFF;
			BUZZ_OFF();
		}
		else if(execution_count < 15000)
		{
			LED_2_ON;
			BUZZ_ON();
		}
		else
		{
			LED_2_OFF;
			BUZZ_OFF();
			execution_count = 0;
			received_operation_count--;
			if(received_operation_count == 0)
			{
				execution_users_operation = EXECUTION_NONE;
			}
		}
		//---------------------------------------
		execution_count++;
		if(execution_count > 15000)
			execution_count = 0;
		//---------------------------------------
	}
	//---------------------------------------
	if(timer0_counter < 100)
		LED_1_ON;
	else
		LED_1_OFF;
	//---------------------------------------
}
/*
********************************************************************************
* main Start
********************************************************************************
*/
//
int main(void)
{
	//---------------------------------------
	//---------------------------------------
	INIT_PORT();
	INIT_UART1(BAUD_115200);
	INIT_UART0(BAUD_115200);
	INIT_TIMER0();
	sei();
	//---------------------------------------
	RESET_PORT_LOW;
	//
	cr0_check_flag = 0;
	lf_check_flag = 0;
	step_count = STEP_0_INIT_EEPROM;
	execution_users_operation = EXECUTION_NONE;
	received_operation_count = 0;
	execution_count = 0;
	//---------------------------------------
	DISPSTR_UART1((unsigned char *)"\r\n*********************************************\r\n");
	DISPSTR_UART1((unsigned char *)DEVICE_NAME);
	DISPSTR_UART1((unsigned char *)" ");
	DISPSTR_UART1((unsigned char *)DEVICE_VERSION);
	DISPSTR_UART1((unsigned char *)" START\r\n");
	//---------------------------------------
	INIT_BUZZ();
	INIT_LCD();
	INIT_FND();
	INIT_LED();
	INIT_BUZZ();
	//
	RESET_PORT_HIGH;
	//
	while(1)
	{
		switch(step_count)
		{
			case STEP_0_INIT_EEPROM:
				INIT_EEPROM_DATA();
				step_count = STEP_1_DISP_EEPROM;
				break;
			case STEP_1_DISP_EEPROM:
				DISPLAY_EEPROM_DATA();
				step_count = STEP_2_CHECK_CR_LF;
				break;
			case STEP_2_CHECK_CR_LF:
				CHECK_CR_LF_PROCESS();
				break;
			case STEP_3_DATA_PARSING:
				PARSING_PROCESS();
				step_count = STEP_2_CHECK_CR_LF;
				break;
			default:
				break;
		}
		//---------------------------------------
		USERS_OPERATION();
		//---------------------------------------
		CHECK_USERS_INPUT_DATA();
		//---------------------------------------
	}
	//---------------------------------------
}
/*
********************************************************************************
* main End
********************************************************************************
*/

