
/*
*******************************************************************************
	Sequence Description
*******************************************************************************
*/
/*
*******************************************************************************
Include Part
*******************************************************************************
*/
#include "main.h"
#include "util.h"
//
#include "parsing.h"
#include "buzz.h"
#include "fnd.h"
#include "lcd.h"
#include "led.h"
#include "change_address.h"
/*
*******************************************************************************
Define Part
*******************************************************************************
*/
//
#define	STEP_0_INIT_EEPROM		0
#define	STEP_1_DISP_EEPROM		1
#define	STEP_2_CHECK_CR_LF		2
#define	STEP_3_DATA_PARSING		3
//
#define RESET_PORT_HIGH	sbi(PORTC,PC1)
#define RESET_PORT_LOW		cbi(PORTC,PC1)
/*
********************************************************************************
Variable Declaration Part
********************************************************************************
*/
unsigned char step_count;
/*
********************************************************************************
Function For Initialize PORT
********************************************************************************
*/
void INIT_PORT ()
{
	//Ʈ A  (= 1111 1111)
	DDRA  = 0xff;
	//Ʈ A ʱⰪ 
	PORTA = 0x00;
	//
	//Ʈ B  (= 1111 1111)
	DDRB  = 0xff;
	//Ʈ B ʱⰪ High (= 1111 1111)
	PORTB = 0xff;
	//
	//Ʈ C  
	DDRC  = 0x03;
	//Ʈ C ʱⰪ 
	PORTC = 0x03;
	//
	//Ʈ D  
	DDRD  = 0x38;
	//Ʈ D ʱⰪ 
	PORTD = 0x38;
	//
	//Ʈ E  
	DDRE  = 0x3e;
	//Ʈ E ʱⰪ 
	PORTE = 0x1f;
	//
	//Ʈ F  (= 1111 1111)
	DDRF  = 0xff;
	//Ʈ F ʱⰪ High (= 1111 1111)
	PORTF = 0xff;
	//
	//Ʈ G  (= xxx1 1111)
	DDRG = 0x00;
	//Ʈ G ʱⰪ High (= 1111 1111)
	PORTG = 0xff;
}
/*
********************************************************************************

********************************************************************************
*/
void DISPLAY_EEPROM_DATA()
{
	DISPSTR_UART1((unsigned char *)"*********************************************\r\n");
	//
	DISPSTR_UART1((unsigned char *)"[LCD OPERATION]\r\n");
	DISPSTR_UART1((unsigned char *)"   ==> ");
	DISPSTR_UART1(received_data_type_adc);
	DISPSTR_UART1((unsigned char *)", ");
	DISPSTR_UART1(received_adc_address);
	//
	DISPSTR_UART1((unsigned char *)"\r\n[FND OPERATION]\r\n");
	DISPSTR_UART1((unsigned char *)"   ==> ");
	DISPSTR_UART1(received_data_type_key_1);
	DISPSTR_UART1((unsigned char *)", ");
	DISPSTR_UART1(received_key_1_address);
	//
	DISPSTR_UART1((unsigned char *)"\r\n[BUZZ OPERATION]\r\n");
	DISPSTR_UART1((unsigned char *)"   ==> ");
	DISPSTR_UART1(received_data_type_key_2);
	DISPSTR_UART1((unsigned char *)", ");
	DISPSTR_UART1(received_key_2_address);
	DISPSTR_UART1((unsigned char *)"\r\n   ==> ");
	DISPSTR_UART1(received_data_type_count);
	DISPSTR_UART1((unsigned char *)", ");
	DISPSTR_UART1(received_count_address);
	//
	DISPSTR_UART1((unsigned char *)"\r\n[LED OPERATION]\r\n");
	DISPSTR_UART1((unsigned char *)"   ==> ");
	DISPSTR_UART1(received_data_type_gpio);
	DISPSTR_UART1((unsigned char *)", ");
	DISPSTR_UART1(received_gpio_address);
	DISPSTR_UART1((unsigned char *)"\r\n*********************************************\r\n");
	DISPSTR_UART1((unsigned char *)"[C: CHANGE PARSING ADDRESS]\r\n");
	DISPSTR_UART1((unsigned char *)"*********************************************\r\n");
}
/*
********************************************************************************

********************************************************************************
*/
void CHECK_CR_LF_PROCESS()
{
	if((cr0_check_flag > 0)&&(lf_check_flag > 0)&&(cr0_check_flag == lf_check_flag))
	{
		//    1  ͸ óϱ    ̸ ̸ üũѴ.
		uart0_length = CHECK_RX_BUF_UART0();
		//
		cr0_check_flag--;
		lf_check_flag--;
		//
		step_count = STEP_3_DATA_PARSING;
	}
}
/*
********************************************************************************

********************************************************************************
*/
void CHECK_USERS_INPUT_DATA()
{
	if(cr1_check_flag == 1)
	{
		cr1_check_flag = 0;
		//
		CHANGE_ADDRESS_PROCESS();
	}
}
/*
********************************************************************************

********************************************************************************
*/
void USERS_OPERATION()
{
	//ADC (  ) ̿Ͽ LCD Ѵ.
	LCD_PROCESS();
	//
	//KEY(1) (׳ƽ  ) ̿ѿ FND Ѵ.
	FND_PROCESS();
	//
	//KEY(2) (Tact ġ ) COUNT ͸ ̿Ͽ  Ѵ.
	BUZZ_PROCESS();
	//
	//GPIO ͸ ̿Ͽ LED Ѵ.
	LED_PROCESS();
	//
	if(timer0_counter < 100)
		LED_1_ON;
	else
		LED_1_OFF;
}
/*
********************************************************************************
* main Start
********************************************************************************
*/
//
int main(void)
{
	INIT_PORT();
	INIT_UART1(BAUD_115200);
	INIT_UART0(BAUD_115200);
	INIT_TIMER0();
	sei();
	//
	RESET_PORT_LOW;
	//
	cr0_check_flag = 0;
	cr1_check_flag = 0;
	lf_check_flag = 0;
	uart0_length = 0;
	step_count = STEP_0_INIT_EEPROM;
	//
	// μ  ȸ ʱȭ
	operation_adc_number = 0;
	operation_key_1_number= 0;
	operation_key_2_number= 0;
	operation_count_number= 0;
	operation_gpio_number= 0;
	//
	// μ   ʱȭ
	operation_adc_process = OPERATION_NO;
	operation_key_1_process = OPERATION_NO;
	operation_key_2_process = OPERATION_NO;
	operation_count_process = OPERATION_NO;
	operation_gpio_process = OPERATION_NO;
	//
	// μ ʱȭ(üũ)
	INIT_BUZZ();
	INIT_LCD();
	INIT_FND();
	INIT_LED();
	INIT_BUZZ();
	//
	DISPSTR_UART1((unsigned char *)"\r\n*********************************************\r\n");
	DISPSTR_UART1((unsigned char *)DEVICE_NAME);
	DISPSTR_UART1((unsigned char *)" ");
	DISPSTR_UART1((unsigned char *)DEVICE_VERSION);
	DISPSTR_UART1((unsigned char *)" START\r\n");
	//
	RESET_PORT_HIGH;
	//
	while(1)
	{
		switch(step_count)
		{
			case STEP_0_INIT_EEPROM:
				INIT_EEPROM_DATA();
				step_count = STEP_1_DISP_EEPROM;
				break;
			case STEP_1_DISP_EEPROM:
				DISPLAY_EEPROM_DATA();
				step_count = STEP_2_CHECK_CR_LF;
				break;
			case STEP_2_CHECK_CR_LF:
				CHECK_CR_LF_PROCESS();
				break;
			case STEP_3_DATA_PARSING:
				PARSING_PROCESS();
				step_count = STEP_2_CHECK_CR_LF;
				break;
			default:
				break;
		}
		//
		USERS_OPERATION();
		//
		CHECK_USERS_INPUT_DATA();
		//
	}
}
/*
********************************************************************************
* main End
********************************************************************************
*/

