
/*
*******************************************************************************
Include Part
*******************************************************************************
*/
#include <avr/io.h>
#include <avr/interrupt.h>
//#include <avr/signal.h>
#include <avr/eeprom.h>
#include  <string.h>
#include  <stdio.h>
#include  <stdlib.h>
/*
*******************************************************************************
Define Part
*******************************************************************************
*/
//
#define EEPROM_DATA_TYPE_ADC		0x00 //3byte
#define EEPROM_ADC_ADDRESS		0x03 //16byte
//
#define EEPROM_DATA_TYPE_KEY_1	0x13 //3byte
#define EEPROM_KEY_1_ADDRESS		0x16 //16byte
//
#define EEPROM_DATA_TYPE_KEY_2	0x26 //3byte
#define EEPROM_KEY_2_ADDRESS		0x29 //16byte
//
#define EEPROM_DATA_TYPE_COUNT	0x39 //3byte
#define EEPROM_COUNT_ADDRESS		0x3C //16byte
//
#define EEPROM_DATA_TYPE_GPIO		0x4C //3byte
#define EEPROM_GPIO_ADDRESS		0x4F //16byte
//
#define OPERATION_NO		0
#define OPERATION_OK		1
//
#define TIMER_OFF	0
#define TIMER_ON	1
//
#define LED_1_ON	cbi(PORTD,PD4)
#define LED_1_OFF	sbi(PORTD,PD4)
#define LED_2_ON	cbi(PORTD,PD5)
#define LED_2_OFF	sbi(PORTD,PD5)
//
/*
********************************************************************************
Variable Declaration Part
********************************************************************************
*/
unsigned char received_data_type_adc[4];
unsigned char received_adc_address[17];
//
unsigned char received_data_type_key_1[4];
unsigned char received_key_1_address[17];
//
unsigned char received_data_type_key_2[4];
unsigned char received_key_2_address[17];
//
unsigned char received_data_type_count[4];
unsigned char received_count_address[17];
//
unsigned char received_data_type_gpio[4];
unsigned char received_gpio_address[17];
//
unsigned char operation_adc_number;
unsigned char operation_key_1_number;
unsigned char operation_key_2_number;
unsigned char operation_count_number;
unsigned char operation_gpio_number;
//
unsigned char operation_adc_value[5];
unsigned int operation_gpio_value;
//
unsigned char operation_adc_process;
unsigned char operation_key_1_process;
unsigned char operation_key_2_process;
unsigned char operation_count_process;
unsigned char operation_gpio_process;
//
unsigned int uart0_length;
/*
*******************************************************************************
Function Prototype Declaration Part
*******************************************************************************
*/
void INIT_PORT(void);
void DISPLAY_EEPROM_DATA(void);
void CHECK_CR_LF_PROCESS(void);
void CHECK_USERS_INPUT_DATA(void);
void USERS_OPERATION(void);
//
//

