
/*
*******************************************************************************
Include Part
*******************************************************************************
*/
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/eeprom.h>
#include  <string.h>
#include  <stdio.h>
#include  <stdlib.h>
/*
*******************************************************************************
Define Part
*******************************************************************************
*/
//
#define EEPROM_DATA_TYPE			0x00 //3byte
#define EEPROM_DATA_VALUE_MIN	0x03 //4byte
#define EEPROM_DATA_VALUE_MAX	0x07 //4byte
#define EEPROM_DATA_ADDRESS		0x0B //16byte
//
#define EXECUTION_NONE	0
#define EXECUTION_OK	1
//
#define LED_1_ON	cbi(PORTD,PD4)
#define LED_1_OFF	sbi(PORTD,PD4)
#define LED_2_ON	cbi(PORTD,PD5)
#define LED_2_OFF	sbi(PORTD,PD5)
//
/*
********************************************************************************
Variable Declaration Part
********************************************************************************
*/
unsigned char received_data_type[4];
unsigned char received_data_value_min[5];
unsigned char received_data_value_max[5];
unsigned char received_data_address[17];
//
unsigned char execution_users_operation;
unsigned int execution_count;
unsigned int received_operation_count;

/*
*******************************************************************************
Function Prototype Declaration Part
*******************************************************************************
*/
void INIT_PORT(void);
void DISPLAY_EEPROM_DATA(void);
void CHECK_CR_LF_PROCESS(void);
void CHECK_USERS_INPUT_DATA(void);
void USERS_OPERATION(void);
//
//

