

/*
*******************************************************************************
Include Part
*******************************************************************************
*/
#include "parsing.h"
#include "util.h"
#include "main.h"
/*
*******************************************************************************
Define Part
*******************************************************************************
*/

/*
********************************************************************************

********************************************************************************
*/
void INIT_EEPROM_DATA()
{
	memset(received_data_type_adc,0x00,4);
	memset(received_data_type_key_1,0x00,4);
	memset(received_data_type_key_2,0x00,4);
	memset(received_data_type_count,0x00,4);
	memset(received_data_type_gpio,0x00,4);
	memset(received_adc_address,0x00,17);
	memset(received_key_1_address,0x00,17);
	memset(received_key_2_address,0x00,17);
	memset(received_count_address,0x00,17);
	memset(received_gpio_address,0x00,17);
	//
	eeprom_read_block(received_data_type_adc, (void *)EEPROM_DATA_TYPE_ADC, 3);
	eeprom_read_block(received_adc_address, (void *)EEPROM_ADC_ADDRESS, 16);
	eeprom_read_block(received_data_type_key_1, (void *)EEPROM_DATA_TYPE_KEY_1, 3);
	eeprom_read_block(received_key_1_address, (void *)EEPROM_KEY_1_ADDRESS, 16);
	eeprom_read_block(received_data_type_key_2, (void *)EEPROM_DATA_TYPE_KEY_2, 3);
	eeprom_read_block(received_key_2_address, (void *)EEPROM_KEY_2_ADDRESS, 16);
	eeprom_read_block(received_data_type_count, (void *)EEPROM_DATA_TYPE_COUNT, 3);
	eeprom_read_block(received_count_address, (void *)EEPROM_COUNT_ADDRESS, 16);
	eeprom_read_block(received_data_type_gpio, (void *)EEPROM_DATA_TYPE_GPIO, 3);
	eeprom_read_block(received_gpio_address, (void *)EEPROM_GPIO_ADDRESS, 16);
	//
	if( (received_data_type_adc[0] == 0xff)
	&&(received_data_type_adc[1] == 0xff)
	&&(received_data_type_adc[2] == 0xff))
	{
		memcpy(received_data_type_adc,"ADC",3);
		memcpy(received_adc_address,"001551000000CC01",16);
		memcpy(received_data_type_key_1,"KEY",3);
		memcpy(received_key_1_address,"001551000000CC0B",16);
		memcpy(received_data_type_key_2,"KEY",3);
		memcpy(received_key_2_address,"001551000000CC25",16);
		memcpy(received_data_type_count,"CNT",3);
		memcpy(received_count_address,"001551000000CC0A",16);
		memcpy(received_data_type_gpio,"GPT",3);
		memcpy(received_gpio_address,"001551000000CC24",16);
		//
		eeprom_write_block(received_data_type_adc, (void *)EEPROM_DATA_TYPE_ADC, 3);
		eeprom_write_block(received_adc_address, (void *)EEPROM_ADC_ADDRESS, 16);
		eeprom_write_block(received_data_type_key_1, (void *)EEPROM_DATA_TYPE_KEY_1, 3);
		eeprom_write_block(received_key_1_address, (void *)EEPROM_KEY_1_ADDRESS, 16);
		eeprom_write_block(received_data_type_key_2, (void *)EEPROM_DATA_TYPE_KEY_2, 3);
		eeprom_write_block(received_key_2_address, (void *)EEPROM_KEY_2_ADDRESS, 16);
		eeprom_write_block(received_data_type_count, (void *)EEPROM_DATA_TYPE_COUNT, 3);
		eeprom_write_block(received_count_address, (void *)EEPROM_COUNT_ADDRESS, 16);
		eeprom_write_block(received_data_type_gpio, (void *)EEPROM_DATA_TYPE_GPIO, 3);
		eeprom_write_block(received_gpio_address, (void *)EEPROM_GPIO_ADDRESS, 16);
		//
		eeprom_read_block(received_data_type_adc, (void *)EEPROM_DATA_TYPE_ADC, 3);
		eeprom_read_block(received_adc_address, (void *)EEPROM_ADC_ADDRESS, 16);
		eeprom_read_block(received_data_type_key_1, (void *)EEPROM_DATA_TYPE_KEY_1, 3);
		eeprom_read_block(received_key_1_address, (void *)EEPROM_KEY_1_ADDRESS, 16);
		eeprom_read_block(received_data_type_key_2, (void *)EEPROM_DATA_TYPE_KEY_2, 3);
		eeprom_read_block(received_key_2_address, (void *)EEPROM_KEY_2_ADDRESS, 16);
		eeprom_read_block(received_data_type_count, (void *)EEPROM_DATA_TYPE_COUNT, 3);
		eeprom_read_block(received_count_address, (void *)EEPROM_COUNT_ADDRESS, 16);
		eeprom_read_block(received_data_type_gpio, (void *)EEPROM_DATA_TYPE_GPIO, 3);
		eeprom_read_block(received_gpio_address, (void *)EEPROM_GPIO_ADDRESS, 16);
	}
}
/*
********************************************************************************

********************************************************************************
*/
unsigned int HEXASCII_TO_INT(unsigned char *hexascii)
{
	unsigned char temp_char_1,temp_char_2,temp_char_3,temp_char_4;
	unsigned int temp_int;
	//
	temp_char_1 = *(hexascii);
	temp_char_2 = *(hexascii+1);
	temp_char_3 = *(hexascii+2);
	temp_char_4 = *(hexascii+3);
	//
	if(temp_char_1 <= 0x39)
	{
		temp_char_1 = temp_char_1 - 0x30;
		temp_char_1 = temp_char_1 << 4;
	}
	else
	{
		temp_char_1 = temp_char_1 - 0x37;
		temp_char_1 = temp_char_1 << 4;
	};
	temp_int = temp_char_1;
	//
	if(temp_char_2 <= 0x39)
	{
		temp_char_2 = temp_char_2 - 0x30;
		temp_char_2 = temp_char_2;
	}
	else
	{
		temp_char_2 = temp_char_2 - 0x37;
		temp_char_2 = temp_char_2;
	};
	temp_int |= temp_char_2;
	//
	temp_int = temp_int << 8;
	//
	if(temp_char_3 <= 0x39)
	{
		temp_char_3 = temp_char_3 - 0x30;
		temp_char_3 = temp_char_3 << 4;
	}
	else
	{
		temp_char_3 = temp_char_3 - 0x37;
		temp_char_3 = temp_char_3 << 4;
	};
	temp_int |= temp_char_3;
	//
	if(temp_char_4 <= 0x39)
	{
		temp_char_4 = temp_char_4 - 0x30;
		temp_char_4 = temp_char_4;
	}
	else
	{
		temp_char_4 = temp_char_4 - 0x37;
		temp_char_4 = temp_char_4;
	};
	temp_int |= temp_char_4;
	//
	return temp_int;
}
/*
********************************************************************************

********************************************************************************
*/
void PARSING_PROCESS()
{
	unsigned char uart0_parsing_buf[60];
	unsigned char loof_count;
	unsigned char value_buf[4];
	unsigned int received_value;
	//
	unsigned char dip_switch_value;
	//
	//uart0_parsing_buf ʱȭ
	memset(uart0_parsing_buf,0x00,60);
	//
	//UART0 Էµ ͸ uart0_parsing_buf Ѵ.
	for(loof_count = 0;loof_count < uart0_length;loof_count++)
	{
		uart0_parsing_buf[loof_count] = GETCHAR_UART0();
	}
	//
	//ADC  ޾(  ), LDC ǥѴ.
	if((!memcmp(received_data_type_adc,&uart0_parsing_buf[uart0_length-26],3))
	&&(!memcmp(received_adc_address,&uart0_parsing_buf[uart0_length-18],16)))
	{
		//ADC  HEXASCII ״ Ѵ.
		memcpy(operation_adc_value,&uart0_parsing_buf[uart0_length-23],4);
		operation_adc_process = OPERATION_OK;
		//
		//ADC Process  ϰ Ѵ.
		operation_adc_number++;
	}
	//
	//KEY(1)  ޾(׳ƽ  ), FND īƮ Ѵ.
	else if((!memcmp(received_data_type_key_1,&uart0_parsing_buf[uart0_length-26],3))
	&&(!memcmp(received_key_1_address,&uart0_parsing_buf[uart0_length-18],16)))
	{
		operation_key_1_process = OPERATION_OK;
		//
		//KEY_1 Process  ϰ Ѵ.
		operation_key_1_number++;
	}
	//
	//KEY(2)  ޾(Tact ġ ),  Ͽ  ¸ ˸.
	else if((!memcmp(received_data_type_key_2,&uart0_parsing_buf[uart0_length-26],3))
	&&(!memcmp(received_key_2_address,&uart0_parsing_buf[uart0_length-18],16)))
	{
		operation_key_2_process = OPERATION_OK;
		//
		//KEY_2 Process  ϰ Ѵ.
		operation_key_2_number++;
	}
	//
	//ī ͸  ϸ,  Ͽ  ̽   ¸ ˸.
	else if((!memcmp(received_data_type_count,&uart0_parsing_buf[uart0_length-26],3))
	&&(!memcmp(received_count_address,&uart0_parsing_buf[uart0_length-18],16)))
	{
		operation_count_process = OPERATION_OK;
		//
		//COUNT Process  ϰ Ѵ.
		operation_count_number++;
	}
	//
	//GPIO ͸ ޾, LED ǥѴ.
	else if((!memcmp(received_data_type_gpio,&uart0_parsing_buf[uart0_length-26],3))
	&&(!memcmp(received_gpio_address,&uart0_parsing_buf[uart0_length-18],16)))
	{
		operation_gpio_process = OPERATION_OK;
		memcpy(value_buf,&uart0_parsing_buf[uart0_length-23],4);
		received_value = HEXASCII_TO_INT(value_buf);
		operation_gpio_value = received_value;
		//
		//GPIO Process  ϰ Ѵ.
		operation_gpio_number++;
	};
	//
	//Dip Switch  д´.
	dip_switch_value = ((PINE & 0xc0)>>4);
	dip_switch_value |= (PIND & 0x03);
	//
	//1 Dip Switch High ,    ø 
	if((dip_switch_value & 0x04) == 0x04)//1xxx
	{
		DISPSTR_UART1(uart0_parsing_buf);
	}
	else
	{
		//ʱ  ڸ üũѴ.
		if(!memcmp("COORD START OK\r\n",&uart0_parsing_buf[uart0_length-16],16))
		{
			DISPSTR_UART1(uart0_parsing_buf);
		}
		//
		//ʱ  ڸ üũѴ.
		else if(!memcmp("TARGET NON\r\n",&uart0_parsing_buf[uart0_length-12],12))
		{
			DISPSTR_UART1(uart0_parsing_buf);
		};
	}
}


