

/*
*******************************************************************************
Include Part
*******************************************************************************
*/
#include "parsing_serial.h"
#include "util.h"
#include "main.h"
/*
*******************************************************************************
Define Part
*******************************************************************************
*/
#define	serial_parsing_data	"0123456789abcdefghij"
/*
********************************************************************************
Function
********************************************************************************
*/
void INIT_EEPROM_DATA()
{
	memset(received_data_type,0x00,4);
	memset(received_data_value_min,0x00,5);
	memset(received_data_value_max,0x00,5);
	memset(received_data_address,0x00,17);
	//---------------------------------------
	eeprom_read_block(received_data_type, (void *)EEPROM_DATA_TYPE, 3);
	eeprom_read_block(received_data_value_min, (void *)EEPROM_DATA_VALUE_MIN, 4);
	eeprom_read_block(received_data_value_max, (void *)EEPROM_DATA_VALUE_MAX, 4);
	eeprom_read_block(received_data_address, (void *)EEPROM_DATA_ADDRESS, 16);
	//---------------------------------------
	if( (received_data_type[0] == 0xff)
	&&(received_data_type[1] == 0xff)
	&&(received_data_type[2] == 0xff))
	{
		//---------------------------------------
		memcpy(received_data_type,"SER",3);
		memcpy(received_data_value_min,"0200",4);
		memcpy(received_data_value_max,"0210",4);
		memcpy(received_data_address,"0000000000000000",16);
		//---------------------------------------
		eeprom_write_block(received_data_type, (void *)EEPROM_DATA_TYPE, 3);
		eeprom_write_block(received_data_value_min, (void *)EEPROM_DATA_VALUE_MIN, 4);
		eeprom_write_block(received_data_value_max, (void *)EEPROM_DATA_VALUE_MAX, 4);
		eeprom_write_block(received_data_address, (void *)EEPROM_DATA_ADDRESS, 16);
		//---------------------------------------
		eeprom_read_block(received_data_type, (void *)EEPROM_DATA_TYPE, 3);
		eeprom_read_block(received_data_value_min, (void *)EEPROM_DATA_VALUE_MIN, 4);
		eeprom_read_block(received_data_value_max, (void *)EEPROM_DATA_VALUE_MAX, 4);
		eeprom_read_block(received_data_address, (void *)EEPROM_DATA_ADDRESS, 16);
		//---------------------------------------
	}
	//---------------------------------------
}
/*
********************************************************************************

********************************************************************************
*/
unsigned int HEXASCII_TO_INT(unsigned char *hexascii)
{
	unsigned char temp_char_1,temp_char_2,temp_char_3,temp_char_4;
	unsigned int temp_int;
	//
	//---------------------------------------
	//---------------------------------------
	temp_char_1 = *(hexascii);
	temp_char_2 = *(hexascii+1);
	temp_char_3 = *(hexascii+2);
	temp_char_4 = *(hexascii+3);
	//---------------------------------------
	if(temp_char_1 <= 0x39)
	{
		temp_char_1 = temp_char_1 - 0x30;
		temp_char_1 = temp_char_1 << 4;
	}
	else
	{
		temp_char_1 = temp_char_1 - 0x37;
		temp_char_1 = temp_char_1 << 4;
	};
	temp_int = temp_char_1;
	//---------------------------------------
	if(temp_char_2 <= 0x39)
	{
		temp_char_2 = temp_char_2 - 0x30;
		temp_char_2 = temp_char_2;
	}
	else
	{
		temp_char_2 = temp_char_2 - 0x37;
		temp_char_2 = temp_char_2;
	};
	temp_int |= temp_char_2;
	//---------------------------------------
	temp_int = temp_int << 8;
	//---------------------------------------
	if(temp_char_3 <= 0x39)
	{
		temp_char_3 = temp_char_3 - 0x30;
		temp_char_3 = temp_char_3 << 4;
	}
	else
	{
		temp_char_3 = temp_char_3 - 0x37;
		temp_char_3 = temp_char_3 << 4;
	};
	temp_int |= temp_char_3;
	//---------------------------------------
	if(temp_char_4 <= 0x39)
	{
		temp_char_4 = temp_char_4 - 0x30;
		temp_char_4 = temp_char_4;
	}
	else
	{
		temp_char_4 = temp_char_4 - 0x37;
		temp_char_4 = temp_char_4;
	};
	temp_int |= temp_char_4;
	//---------------------------------------
	return temp_int;
}
/*
********************************************************************************

********************************************************************************
*/
void PARSING_PROCESS()
{
	unsigned int uart0_length;
	unsigned char uart0_parsing_buf[60];
	unsigned char loof_count;
	//
//	unsigned char value_buf[4];
//	unsigned int received_value;
//	unsigned int min_value;
//	unsigned int max_value;
	//
	//---------------------------------------
	//---------------------------------------
	memset(uart0_parsing_buf,0x00,60);
	uart0_length = CHECK_RX_BUF_UART0();
	if(uart0_length > 0)
	{
		for(loof_count = 0;loof_count < uart0_length;loof_count++)
		{
			uart0_parsing_buf[loof_count] = GETCHAR_UART0();
		}
		//---------------------------------------
		if(!memcmp(uart0_parsing_buf,serial_parsing_data,20))
		{
			execution_users_operation = EXECUTION_OK;
			received_operation_count++;
			//---------------------------------------
			if(received_operation_count > 60000)
				received_operation_count = 0;
			//
			for(loof_count = 0;loof_count < uart0_length-2;loof_count++)
				PUTCHAR_UART1(uart0_parsing_buf[loof_count]);
			DISPSTR_UART1((unsigned char *)" => DETECT\r\n");
		}
		else
		{
			DISPSTR_UART1(uart0_parsing_buf);
		}
		//---------------------------------------
	}
}

