

/*
*******************************************************************************
Include Part
*******************************************************************************
*/
/*
*******************************************************************************
Define Part
*******************************************************************************
*/
#define UART1_BUF_SIZE 128
#define UART0_BUF_SIZE 128
//
#define BAUD_9600		0x05
#define BAUD_19200		0x06
#define BAUD_38400		0x07
#define BAUD_57600		0x08
#define BAUD_115200		0x09
//
#define CR_VALUE		0x0d
#define LF_VALUE		0x0a
//
#define sbi(x,y)x|=_BV(y)
#define cbi(x,y)x&=~(_BV(y))
//
/*
********************************************************************************
Variable Declaration Part
********************************************************************************
*/
unsigned char rx0_buf[UART0_BUF_SIZE];
unsigned char rx1_buf[UART1_BUF_SIZE];
unsigned int p_rx1_wr, p_rx1_rd;
unsigned int p_rx0_wr, p_rx0_rd;
//
unsigned int timer0_counter;
//
unsigned char cr0_check_flag;
unsigned char cr1_check_flag;
unsigned char lf_check_flag;
//
unsigned int timer_buzz_1;
unsigned int timer_buzz_2;
unsigned int timer_buzz_3;
unsigned int timer_lcd;
/*
*******************************************************************************
Function Prototype Declaration Part
*******************************************************************************
*/
void INIT_UART0(unsigned char baudrate);
unsigned int CHECK_RX_BUF_UART0(void);
unsigned char GETCHAR_UART0 (void);
unsigned char PUTCHAR_UART0 (unsigned char c);
void DISPSTR_UART0 (unsigned char *s);
void DISPLAY_CR_LF_UART0(void);
//
void INIT_UART1(unsigned char baudrate);
unsigned int CHECK_RX_BUF_UART1(void);
unsigned char GETCHAR_UART1 (void);
unsigned char PUTCHAR_UART1 (unsigned char c);
void DISPSTR_UART1 (unsigned char *s);
void DISPLAY_CR_LF_UART1(void);
//
unsigned char HEX2CHAR(unsigned char c);
//
void INIT_TIMER0(void);
//
void WAIT_1MS(unsigned int cnt);
void WAIT_1US(unsigned int cnt);
//



